Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.gui
Class QMainWindow

    java.lang.Object
      com.trolltech.qt.internal.QSignalEmitterInternal
          com.trolltech.qt.QSignalEmitter
              com.trolltech.qt.QtJambiObject
                  com.trolltech.qt.core.QObject
                      com.trolltech.qt.gui.QWidget
                          com.trolltech.qt.gui.QMainWindow

All Implemented Interfaces:
  QPaintDeviceInterface, QtJambiInterface

    public class QMainWindow

extends QWidget

The `QMainWindow` class provides a main application window.

- Qt Main Window Framework
- Creating Main Window Components

- Creating Menus
- Creating Toolbars
- Creating Dock Widgets
- The Status Bar

- Storing State

## Qt Main Window Framework

A main window provides a framework for building an application's user interface. Qt has `QMainWindow` and its related classes for main window management. `QMainWindow` has its own layout to which you can add `QToolBar`s, `QDockWidget`s, a `QMenuBar`, and a `QStatusBar`. The layout has a center area that can be occupied by any kind of widget. You can see an image of the layout below.
Note: Creating a main window without a central widget is not supported. You must have a central widget even if it is just a placeholder.

## Creating Main Window Components

A central widget will typically be a standard Qt widget such as a `QTextEdit` or a `QGraphicsView`. Custom widgets can also be used for advanced applications. You set the central widget with `setCentralWidget()`.

Main windows have either a single (SDI) or multiple (MDI) document interface. You create MDI applications in Qt by using a `QMdiArea` as the central widget.

We will now examine each of the other widgets that can be added to a main window. We give examples on how to create and add them.

### Creating Menus

Qt implements menus in `QMenu` and `QMainWindow` keeps them in a `QMenuBar`. `QAction`s are added to the menus, which display them as menu items.

You can add new menus to the main window's menu bar by calling `menuBar()`, which returns the `QMenuBar` for the window, and then add a menu with `QMenuBar::addMenu()`.

`QMainWindow` comes with a default menu bar, but you can also set one yourself with `setMenuBar()`. If you wish to implement a custom menu bar (i.e., not use the `QMenuBar` widget), you can set it with `setMenuWidget()`.

An example of how to create menus follows:
The following code example is written in c++.

    void MainWindow::createMenus()

    {
        fileMenu = menuBar()->addMenu(tr("&File"));
        fileMenu->addAction(newAct);

        fileMenu->addAction(openAct);

        fileMenu->addAction(saveAct);

The `createPopupMenu()` function creates popup menus when the main window receives context menu events. The default implementation generates a menu with the checkable actions from the dock widgets and toolbars. You can reimplement `createPopupMenu()` for a custom menu.

### Creating Toolbars

Toolbars are implemented in the `QToolBar` class. You add a toolbar to a main window with `addToolBar()`.

You control the initial position of toolbars by assigning them to a specific `Qt::ToolBarArea` . You can split an area by inserting a toolbar break - think of this as a line break in text editing - with `addToolBarBreak()` or `insertToolBarBreak()`. You can also restrict placement by the user with `QToolBar::setAllowedAreas()` and `QToolBar::setMovable()`.

The size of toolbar icons can be retrieved with `iconSize()`. The sizes are platform dependent; you can set a fixed size with `setIconSize()`. You can alter the appearance of all tool buttons in the toolbars with `setToolButtonStyle()`.

An example of toolbar creation follows:
The following code example is written in c++.

    void MainWindow::createToolBars()
    {
        fileToolBar = addToolBar(tr("File"));
        fileToolBar->addAction(newAct);

### Creating Dock Widgets

Dock widgets are implemented in the `QDockWidget` class. A dock widget is a window that can be docked into the main window. You add dock widgets to a main window with `addDockWidget()`.

There are four dock widget areas as given by the `Qt::DockWidgetArea` enum: left, right, top, and bottom. You can specify which dock widget area that should occupy the corners where the areas overlap with `setCorner()`. By default each area can only contain one row (vertical or horizontal) of dock widgets, but if you enable nesting with `setDockNestingEnabled()`, dock widgets can be added in either direction.

Two dock widgets may also be stacked on top of each other. A `QTabBar` is then used to select which of the widgets that should be displayed.

We give an example of how to create and add dock widgets to a main window:

            QDockWidget dockWidget = new QDockWidget(tr("Dock Widget"), this);
            dockWidget.setAllowedAreas(Qt.DockWidgetArea.LeftDockWidgetArea);
            dockWidget.setWidget(dockWidgetContents);
            addDockWidget(Qt.DockWidgetArea.LeftDockWidgetArea, dockWidget);

### The Status Bar

You can set a status bar with `setStatusBar()`, but one is created the first time `statusBar()` (which returns the main window's status bar) is called. See `QStatusBar` for information on how to use it.

## Storing State

`QMainWindow` can store the state of its layout with `saveState()`; it can later be retrieved with `restoreState()`. It is the position and size (relative to the size of the main window) of the toolbars and dock widgets that are stored.

See also:
  `QMenuBar`, `QToolBar`, `QStatusBar`, `QDockWidget`, Application Example, Dock Widgets Example, MDI Example, SDI Example, and Menus Example.

Nested Class Summary
`static class` | `QMainWindow.DockOption` This enum contains flags that specify the docking behavior of `QMainWindow`.
`static class` | `QMainWindow.DockOptions` This is a flags class for com.trolltech.qt.gui.QMainWindow.DockOption

Nested classes/interfaces inherited from class com.trolltech.qt.gui.QWidget
`QWidget.RenderFlag, QWidget.RenderFlags`

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Nested classes/interfaces inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`com.trolltech.qt.internal.QSignalEmitterInternal.AbstractSignalInternal`

Field Summary
`QSignalEmitter.Signal1` | `iconSizeChanged` This signal takes 1 generic argument(s).
`QSignalEmitter.Signal1` | `toolButtonStyleChanged` This signal takes 1 generic argument(s).

Fields inherited from class com.trolltech.qt.gui.QWidget
`customContextMenuRequested`

Fields inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`currentSender`

Constructor Summary
`QMainWindow()` Constructs a `QMainWindow` with the given `parent` and the specified widget `flags`.
`QMainWindow(QWidget parent)` Constructs a `QMainWindow` with the given `parent` and the specified widget `flags`.
`QMainWindow(QWidget parent, Qt.WindowFlags flags)` Constructs a `QMainWindow` with the given `parent` and the specified widget `flags`.
`QMainWindow(QWidget parent, Qt.WindowType[] flags)` Constructs a `QMainWindow` with the given `parent` and the specified widget `flags`.

Method Summary
`void` | `addDockWidget(Qt.DockWidgetArea area, QDockWidget dockwidget)` Adds the given `dockwidget` to the specified `area`.
`void` | `addDockWidget(Qt.DockWidgetArea area, QDockWidget dockwidget, Qt.Orientation orientation)` Adds `dockwidget` into the given `area` in the direction specified by the `orientation`.
`void` | `addToolBar(Qt.ToolBarArea area, QToolBar toolbar)` Adds the `toolbar` into the specified `area` in this main window.
`void` | `addToolBar(QToolBar toolbar)` Equivalent of calling addToolBar(`Qt::TopToolBarArea` , `toolbar`)
`QToolBar` | `addToolBar(java.lang.String title)` Creates a `QToolBar` object, setting its window title to `title`, and inserts it into the top toolbar area.
`void` | `addToolBarBreak()` Adds a toolbar break to the given `area` after all the other objects that are present.
`void` | `addToolBarBreak(Qt.ToolBarArea area)` Adds a toolbar break to the given `area` after all the other objects that are present.
`QWidget` | `centralWidget()` Returns the central widget for the main window.
`Qt.DockWidgetArea` | `corner(Qt.Corner corner)` Returns the dock widget area that occupies the specified `corner`.
`QMenu` | `createPopupMenu()` Returns a popup menu containing checkable entries for the toolbars and dock widgets present in the main window.
`QMainWindow.DockOptions` | `dockOptions()` This property holds the docking behavior of `QMainWindow`.
`Qt.DockWidgetArea` | `dockWidgetArea(QDockWidget dockwidget)` Returns the `Qt::DockWidgetArea` for `dockwidget`.
`QSize` | `iconSize()` This property holds size of toolbar icons in this mainwindow.
`void` | `insertToolBar(QToolBar before, QToolBar toolbar)` Inserts the `toolbar` into the area occupied by the `before` toolbar so that it appears before it.
`void` | `insertToolBarBreak(QToolBar before)` Inserts a toolbar break before the toolbar specified by `before`.
`boolean` | `isAnimated()` This property holds whether manipulating dock widgets and tool bars is animated.
`boolean` | `isDockNestingEnabled()` This property holds whether docks can be nested.
`QMenuBar` | `menuBar()` Returns the menu bar for the main window.
`QWidget` | `menuWidget()` Returns the menu bar for the main window.
`void` | `removeDockWidget(QDockWidget dockwidget)` Removes the `dockwidget` from the main window layout and hides it.
`void` | `removeToolBar(QToolBar toolbar)` Removes the `toolbar` from the main window layout and hides it.
`void` | `removeToolBarBreak(QToolBar before)` Removes a toolbar break previously inserted before the toolbar specified by `before`.
`boolean` | `restoreDockWidget(QDockWidget dockwidget)` Restores the state of `dockwidget` if it is created after the call to `restoreState()`.
`boolean` | `restoreState(QByteArray state)` Restores the `state` of this mainwindow's toolbars and dockwidgets.
`boolean` | `restoreState(QByteArray state, int version)` Restores the `state` of this mainwindow's toolbars and dockwidgets.
`QByteArray` | `saveState()` Saves the current state of this mainwindow's toolbars and dockwidgets.
`QByteArray` | `saveState(int version)` Saves the current state of this mainwindow's toolbars and dockwidgets.
`void` | `setAnimated(boolean enabled)` This property holds whether manipulating dock widgets and tool bars is animated.
`void` | `setCentralWidget(QWidget widget)` Sets the given `widget` to be the main window's central widget.
`void` | `setCorner(Qt.Corner corner, Qt.DockWidgetArea area)` Sets the given dock widget `area` to occupy the specified `corner`.
`void` | `setDockNestingEnabled(boolean enabled)` This property holds whether docks can be nested.
`void` | `setDockOptions(QMainWindow.DockOption[] options)` This property holds the docking behavior of `QMainWindow`.
`void` | `setDockOptions(QMainWindow.DockOptions options)` This property holds the docking behavior of `QMainWindow`.
`void` | `setIconSize(QSize iconSize)` This property holds size of toolbar icons in this mainwindow.
`void` | `setMenuBar(QMenuBar menubar)` Sets the menu bar for the main window to `menuBar`.
`void` | `setMenuWidget(QWidget menubar)` Sets the menu bar for the main window to `menuBar`.
`void` | `setStatusBar(QStatusBar statusbar)` Sets the status bar for the main window to `statusbar`.
`void` | `setToolButtonStyle(Qt.ToolButtonStyle toolButtonStyle)` This property holds style of toolbar buttons in this mainwindow.
`void` | `setUnifiedTitleAndToolBarOnMac(boolean set)` This property holds whether the window uses the unified title and toolbar look on Mac OS X.
`void` | `splitDockWidget(QDockWidget after, QDockWidget dockwidget, Qt.Orientation orientation)` Splits the space covered by the `first` dock widget into two parts, moves the `first` dock widget into the first part, and moves the `second` dock widget into the second part.
`QStatusBar` | `statusBar()` Returns the status bar for the main window.
`void` | `tabifyDockWidget(QDockWidget first, QDockWidget second)` Moves `second` dock widget on top of `first` dock widget, creating a tabbed docked area in the main window.
`Qt.ToolBarArea` | `toolBarArea(QToolBar toolbar)` Returns the `Qt::ToolBarArea` for `toolbar`.
`boolean` | `toolBarBreak(QToolBar toolbar)` Returns whether there is a toolbar break before the `toolbar`.
`Qt.ToolButtonStyle` | `toolButtonStyle()` This property holds style of toolbar buttons in this mainwindow.
`boolean` | `unifiedTitleAndToolBarOnMac()` This property holds whether the window uses the unified title and toolbar look on Mac OS X.

Methods inherited from class com.trolltech.qt.gui.QWidget
`acceptDrops, accessibleDescription, accessibleName, actionEvent, actions, activateWindow, addAction, addActions, adjustSize, autoFillBackground, backgroundRole, baseSize, changeEvent, childAt, childAt, childrenRect, childrenRegion, clearFocus, clearMask, close, closeEvent, contentsRect, contextMenuEvent, contextMenuPolicy, cursor, depth, destroy, destroy, destroy, dragEnterEvent, dragLeaveEvent, dragMoveEvent, dropEvent, effectiveWinId, ensurePolished, enterEvent, focusInEvent, focusNextChild, focusNextPrevChild, focusOutEvent, focusPolicy, focusPreviousChild, focusProxy, focusWidget, font, fontInfo, fontMetrics, foregroundRole, frameGeometry, frameSize, geometry, getContentsMargins, grabKeyboard, grabMouse, grabMouse, grabShortcut, grabShortcut, hasFocus, hasMouseTracking, height, heightForWidth, heightMM, hide, hideEvent, inputContext, inputMethodEvent, inputMethodQuery, insertAction, insertActions, isActiveWindow, isAncestorOf, isEnabled, isEnabledTo, isFullScreen, isHidden, isMaximized, isMinimized, isModal, isVisible, isVisibleTo, isWindow, isWindowModified, keyboardGrabber, keyPressEvent, keyReleaseEvent, languageChange, layout, layoutDirection, leaveEvent, locale, logicalDpiX, logicalDpiY, lower, mapFrom, mapFromGlobal, mapFromParent, mapTo, mapToGlobal, mapToParent, mask, maximumHeight, maximumSize, maximumWidth, metric, minimumHeight, minimumSize, minimumSizeHint, minimumWidth, mouseDoubleClickEvent, mouseGrabber, mouseMoveEvent, mousePressEvent, mouseReleaseEvent, move, move, moveEvent, nativeParentWidget, nextInFocusChain, normalGeometry, numColors, overrideWindowFlags, overrideWindowFlags, paintEngine, paintEvent, paintingActive, palette, parentWidget, physicalDpiX, physicalDpiY, pos, raise, rect, releaseKeyboard, releaseMouse, releaseShortcut, removeAction, render, render, render, render, render, render, render, render, render, repaint, repaint, repaint, repaint, resetInputContext, resize, resize, resizeEvent, restoreGeometry, saveGeometry, scroll, scroll, setAcceptDrops, setAccessibleDescription, setAccessibleName, setAttribute, setAttribute, setAutoFillBackground, setBackgroundRole, setBaseSize, setBaseSize, setContentsMargins, setContentsMargins, setContextMenuPolicy, setCursor, setDisabled, setEnabled, setFixedHeight, setFixedSize, setFixedSize, setFixedWidth, setFocus, setFocus, setFocusPolicy, setFocusProxy, setFont, setForegroundRole, setGeometry, setGeometry, setHidden, setInputContext, setLayout, setLayoutDirection, setLocale, setMask, setMask, setMaximumHeight, setMaximumSize, setMaximumSize, setMaximumWidth, setMinimumHeight, setMinimumSize, setMinimumSize, setMinimumWidth, setMouseTracking, setPalette, setParent, setParent, setParent, setShortcutAutoRepeat, setShortcutAutoRepeat, setShortcutEnabled, setShortcutEnabled, setSizeIncrement, setSizeIncrement, setSizePolicy, setSizePolicy, setStatusTip, setStyle, setStyleSheet, setTabOrder, setToolTip, setUpdatesEnabled, setVisible, setWhatsThis, setWindowFilePath, setWindowFlags, setWindowFlags, setWindowIcon, setWindowIconText, setWindowModality, setWindowModified, setWindowOpacity, setWindowRole, setWindowState, setWindowState, setWindowTitle, show, showEvent, showFullScreen, showMaximized, showMinimized, showNormal, size, sizeHint, sizeIncrement, sizePolicy, stackUnder, statusTip, style, styleSheet, tabletEvent, testAttribute, toolTip, underMouse, unsetCursor, unsetLayoutDirection, unsetLocale, update, update, update, update, updateGeometry, updateMicroFocus, updatesEnabled, visibleRegion, whatsThis, wheelEvent, width, widthMM, window, windowFilePath, windowFlags, windowIcon, windowIconText, windowModality, windowOpacity, windowRole, windowState, windowTitle, windowType, winId, x, y`

Methods inherited from class com.trolltech.qt.core.QObject
`childEvent, children, connectSlotsByName, customEvent, disposeLater, dumpObjectInfo, dumpObjectTree, dynamicPropertyNames, event, eventFilter, findChild, findChild, findChild, findChildren, findChildren, findChildren, findChildren, indexOfProperty, installEventFilter, isWidgetType, killTimer, moveToThread, objectName, parent, properties, property, removeEventFilter, setObjectName, setParent, setProperty, startTimer, timerEvent, toString, userProperty`

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`__qt_signalInitialization`

Methods inherited from class java.lang.Object
`clone, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Field Detail

### iconSizeChanged

    public final QSignalEmitter.Signal1 iconSizeChanged

  This signal takes 1 generic argument(s). We list their type and the name they go by in the description of this signal. <com.trolltech.qt.core.QSize(named: iconSize)>:

  This signal is emitted when the size of the icons used in the window is changed. The new icon size is passed in `iconSize`.

  You can connect this signal to other components to help maintain a consistent appearance for your application.

See also:
  `setIconSize()`.

### toolButtonStyleChanged

    public final QSignalEmitter.Signal1 toolButtonStyleChanged

  This signal takes 1 generic argument(s). We list their type and the name they go by in the description of this signal. <com.trolltech.qt.core.Qt$ToolButtonStyle(named: toolButtonStyle)>:

  This signal is emitted when the style used for tool buttons in the window is changed. The new style is passed in `toolButtonStyle`.

  You can connect this signal to other components to help maintain a consistent appearance for your application.

See also:
  `setToolButtonStyle()`.

Constructor Detail

### QMainWindow

    public QMainWindow(QWidget parent,
                       Qt.WindowType[] flags)

  Constructs a `QMainWindow` with the given `parent` and the specified widget `flags`.

### QMainWindow

    public QMainWindow(QWidget parent)

  Constructs a `QMainWindow` with the given `parent` and the specified widget `flags`.

### QMainWindow

    public QMainWindow()

  Constructs a `QMainWindow` with the given `parent` and the specified widget `flags`.

### QMainWindow

    public QMainWindow(QWidget parent,
                       Qt.WindowFlags flags)

  Constructs a `QMainWindow` with the given `parent` and the specified widget `flags`.

Method Detail

### addDockWidget

    public final void addDockWidget(Qt.DockWidgetArea area,
                                    QDockWidget dockwidget)

  Adds the given `dockwidget` to the specified `area`.

### addDockWidget

    public final void addDockWidget(Qt.DockWidgetArea area,
                                    QDockWidget dockwidget,
                                    Qt.Orientation orientation)

  Adds `dockwidget` into the given `area` in the direction specified by the `orientation`.

### addToolBar

    public final void addToolBar(QToolBar toolbar)

  Equivalent of calling addToolBar(`Qt::TopToolBarArea` , `toolbar`)

### addToolBar

    public final void addToolBar(Qt.ToolBarArea area,
                                 QToolBar toolbar)

  Adds the `toolbar` into the specified `area` in this main window. The `toolbar` is placed at the end of the current tool bar block (i.e. line). If the main window already manages `toolbar` then it will only move the toolbar to `area`.

See also:
  `insertToolBar()`, `addToolBarBreak()`, and `insertToolBarBreak()`.

### addToolBar

    public final QToolBar addToolBar(java.lang.String title)

  Creates a `QToolBar` object, setting its window title to `title`, and inserts it into the top toolbar area.

See also:
  setWindowTitle().

### addToolBarBreak

    public final void addToolBarBreak()

  Adds a toolbar break to the given `area` after all the other objects that are present.

### addToolBarBreak

    public final void addToolBarBreak(Qt.ToolBarArea area)

  Adds a toolbar break to the given `area` after all the other objects that are present.

### centralWidget

    public final QWidget centralWidget()

  Returns the central widget for the main window. This function returns zero if the central widget has not been set.

See also:
  `setCentralWidget()`.

### corner

    public final Qt.DockWidgetArea corner(Qt.Corner corner)

  Returns the dock widget area that occupies the specified `corner`.

See also:
  `setCorner()`.

### dockOptions

    public final QMainWindow.DockOptions dockOptions()

  This property holds the docking behavior of `QMainWindow`. The default value is `AnimatedDocks` | `AllowTabbedDocks` .

### dockWidgetArea

    public final Qt.DockWidgetArea dockWidgetArea(QDockWidget dockwidget)

  Returns the `Qt::DockWidgetArea` for `dockwidget`. If `dockwidget` has not been added to the main window, this function returns `Qt::NoDockWidgetArea`.

See also:
  `addDockWidget()`, `splitDockWidget()`, and `Qt::DockWidgetArea` .

### iconSize

    public final QSize iconSize()

  This property holds size of toolbar icons in this mainwindow. The default is the default tool bar icon size of the GUI style. Note that the icons used must be at least of this size as the icons are only scaled down.

### insertToolBar

    public final void insertToolBar(QToolBar before,
                                    QToolBar toolbar)

  Inserts the `toolbar` into the area occupied by the `before` toolbar so that it appears before it. For example, in normal left-to-right layout operation, this means that `toolbar` will appear to the left of the toolbar specified by `before` in a horizontal toolbar area.

See also:
  `insertToolBarBreak()`, `addToolBar()`, and `addToolBarBreak()`.

### insertToolBarBreak

    public final void insertToolBarBreak(QToolBar before)

  Inserts a toolbar break before the toolbar specified by `before`.

### isAnimated

    public final boolean isAnimated()

  This property holds whether manipulating dock widgets and tool bars is animated. When a dock widget or tool bar is dragged over the main window, the main window adjusts its contents to indicate where the dock widget or tool bar will be docked if it is dropped. Setting this property causes `QMainWindow` to move its contents in a smooth animation. Clearing this property causes the contents to snap into their new positions.

  By default, this property is set. It may be cleared if the main window contains widgets which are slow at resizing or repainting themselves.

  Setting this property is identical to setting the `AnimatedDocks` option using `setDockOptions()`.

### isDockNestingEnabled

    public final boolean isDockNestingEnabled()

  This property holds whether docks can be nested. If this property is false, dock areas can only contain a single row (horizontal or vertical) of dock widgets. If this property is true, the area occupied by a dock widget can be split in either direction to contain more dock widgets.

  Dock nesting is only necessary in applications that contain a lot of dock widgets. It gives the user greater freedom in organizing their main window. However, dock nesting leads to more complex (and less intuitive) behavior when a dock widget is dragged over the main window, since there are more ways in which a dropped dock widget may be placed in the dock area.

  Setting this property is identical to setting the `AllowNestedDocks` option using `setDockOptions()`.

### menuBar

    public final QMenuBar menuBar()

  Returns the menu bar for the main window. This function creates and returns an empty menu bar if the menu bar does not exist.

  If you want all windows in a Mac application to share one menu bar, don't use this function to create it, because the menu bar created here will have this `QMainWindow` as its parent. Instead, you must create a menu bar that does not have a parent, which you can then share among all the Mac windows. Create a parent-less menu bar this way:

              QMenuBar menuBar = new QMenuBar();

See also:
  `setMenuBar()`.

### menuWidget

    public final QWidget menuWidget()

  Returns the menu bar for the main window. This function returns null if a menu bar hasn't been constructed yet.

See also:
  `setMenuWidget()`.

### removeDockWidget

    public final void removeDockWidget(QDockWidget dockwidget)

  Removes the `dockwidget` from the main window layout and hides it. Note that the `dockwidget` is not deleted.

### removeToolBar

    public final void removeToolBar(QToolBar toolbar)

  Removes the `toolbar` from the main window layout and hides it. Note that the `toolbar` is not deleted.

### removeToolBarBreak

    public final void removeToolBarBreak(QToolBar before)

  Removes a toolbar break previously inserted before the toolbar specified by `before`.

### restoreDockWidget

    public final boolean restoreDockWidget(QDockWidget dockwidget)

  Restores the state of `dockwidget` if it is created after the call to `restoreState()`. Returns true if the state was restored; otherwise returns false.

### restoreState

    public final boolean restoreState(QByteArray state)

  Restores the `state` of this mainwindow's toolbars and dockwidgets. The `version` number is compared with that stored in `state`. If they do not match, the mainwindow's state is left unchanged, and this function returns `false`; otherwise, the state is restored, and this function returns `true`.

See also:
  `saveState()`.

### restoreState

    public final boolean restoreState(QByteArray state,
                                      int version)

  Restores the `state` of this mainwindow's toolbars and dockwidgets. The `version` number is compared with that stored in `state`. If they do not match, the mainwindow's state is left unchanged, and this function returns `false`; otherwise, the state is restored, and this function returns `true`.

See also:
  `saveState()`.

### saveState

    public final QByteArray saveState()

  Saves the current state of this mainwindow's toolbars and dockwidgets. The `version` number is stored as part of the data.

  The `objectName` property is used to identify each `QToolBar` and `QDockWidget`. You should make sure that this property is unique for each `QToolBar` and `QDockWidget` you add to the `QMainWindow`

  To restore the saved state, pass the return value and `version` number to `restoreState()`.

See also:
  `restoreState()`.

### saveState

    public final QByteArray saveState(int version)

  Saves the current state of this mainwindow's toolbars and dockwidgets. The `version` number is stored as part of the data.

  The `objectName` property is used to identify each `QToolBar` and `QDockWidget`. You should make sure that this property is unique for each `QToolBar` and `QDockWidget` you add to the `QMainWindow`

  To restore the saved state, pass the return value and `version` number to `restoreState()`.

See also:
  `restoreState()`.

### setAnimated

    public final void setAnimated(boolean enabled)

  This property holds whether manipulating dock widgets and tool bars is animated. When a dock widget or tool bar is dragged over the main window, the main window adjusts its contents to indicate where the dock widget or tool bar will be docked if it is dropped. Setting this property causes `QMainWindow` to move its contents in a smooth animation. Clearing this property causes the contents to snap into their new positions.

  By default, this property is set. It may be cleared if the main window contains widgets which are slow at resizing or repainting themselves.

  Setting this property is identical to setting the `AnimatedDocks` option using `setDockOptions()`.

### setCentralWidget

    public final void setCentralWidget(QWidget widget)

  Sets the given `widget` to be the main window's central widget.

  Note: `QMainWindow` takes ownership of the `widget` pointer and deletes it at the appropriate time.

See also:
  `centralWidget()`.

### setCorner

    public final void setCorner(Qt.Corner corner,
                                Qt.DockWidgetArea area)

  Sets the given dock widget `area` to occupy the specified `corner`.

See also:
  `corner()`.

### setDockNestingEnabled

    public final void setDockNestingEnabled(boolean enabled)

  This property holds whether docks can be nested. If this property is false, dock areas can only contain a single row (horizontal or vertical) of dock widgets. If this property is true, the area occupied by a dock widget can be split in either direction to contain more dock widgets.

  Dock nesting is only necessary in applications that contain a lot of dock widgets. It gives the user greater freedom in organizing their main window. However, dock nesting leads to more complex (and less intuitive) behavior when a dock widget is dragged over the main window, since there are more ways in which a dropped dock widget may be placed in the dock area.

  Setting this property is identical to setting the `AllowNestedDocks` option using `setDockOptions()`.

### setDockOptions

    public final void setDockOptions(QMainWindow.DockOption[] options)

  This property holds the docking behavior of `QMainWindow`. The default value is `AnimatedDocks` | `AllowTabbedDocks` .

### setDockOptions

    public final void setDockOptions(QMainWindow.DockOptions options)

  This property holds the docking behavior of `QMainWindow`. The default value is `AnimatedDocks` | `AllowTabbedDocks` .

### setIconSize

    public final void setIconSize(QSize iconSize)

  This property holds size of toolbar icons in this mainwindow. The default is the default tool bar icon size of the GUI style. Note that the icons used must be at least of this size as the icons are only scaled down.

### setMenuBar

    public final void setMenuBar(QMenuBar menubar)

  Sets the menu bar for the main window to `menuBar`.

  Note: `QMainWindow` takes ownership of the `menuBar` pointer and deletes it at the appropriate time.

See also:
  `menuBar()`.

### setMenuWidget

    public final void setMenuWidget(QWidget menubar)

  Sets the menu bar for the main window to `menuBar`.

  `QMainWindow` takes ownership of the `menuBar` pointer and deletes it at the appropriate time.

See also:
  `menuWidget()`.

### setStatusBar

    public final void setStatusBar(QStatusBar statusbar)

  Sets the status bar for the main window to `statusbar`.

  Setting the status bar to 0 will remove it from the main window. Note that `QMainWindow` takes ownership of the `statusbar` pointer and deletes it at the appropriate time.

See also:
  `statusBar()`.

### setToolButtonStyle

    public final void setToolButtonStyle(Qt.ToolButtonStyle toolButtonStyle)

  This property holds style of toolbar buttons in this mainwindow. The default is `Qt::ToolButtonIconOnly` .

### setUnifiedTitleAndToolBarOnMac

    public final void setUnifiedTitleAndToolBarOnMac(boolean set)

  This property holds whether the window uses the unified title and toolbar look on Mac OS X. This property is false by default and only has any effect on Mac OS X 10.4 or higher.

  If set to true, then the top toolbar area is replaced with a Carbon HIToolbar and all toolbars in the top toolbar area are moved to that. Any toolbars added afterwards will also be added to the Carbon HIToolbar. This means a couple of things.

  - QToolBars in this toolbar area are not movable and you cannot drag other toolbars to it
  - Toolbar breaks are not respected or preserved
  - Any custom widgets in the toolbar will not be shown if the toolbar becomes too small (only actions will be shown)
  - If you call `showFullScreen()` on the main window, the QToolbar will disappear since it is considered to be part of the title bar. You can work around this by turning off the unified toolbar before you call `showFullScreen()` and restoring it after you call `showNormal()`.
  Setting this back to false will remove these restrictions.

  The `Qt::WA_MacBrushedMetal` attribute takes precedence over this property.

### splitDockWidget

    public final void splitDockWidget(QDockWidget after,
                                      QDockWidget dockwidget,
                                      Qt.Orientation orientation)

  Splits the space covered by the `first` dock widget into two parts, moves the `first` dock widget into the first part, and moves the `second` dock widget into the second part.

  The `orientation` specifies how the space is divided: A `Qt::Horizontal` split places the second dock widget to the right of the first; a `Qt::Vertical` split places the second dock widget below the first.

  Note: if `first` is currently in a tabbed docked area, `second` will be added as a new tab, not as a neighbor of `first`. This is because a single tab can contain only one dock widget.

  Note: The `Qt::LayoutDirection` influences the order of the dock widgets in the two parts of the divided area. When right-to-left layout direction is enabled, the placing of the dock widgets will be reversed.

See also:
  `tabifyDockWidget()`, `addDockWidget()`, and `removeDockWidget()`.

### statusBar

    public final QStatusBar statusBar()

  Returns the status bar for the main window. This function creates and returns an empty status bar if the status bar does not exist.

See also:
  `setStatusBar()`.

### tabifyDockWidget

    public final void tabifyDockWidget(QDockWidget first,
                                       QDockWidget second)

  Moves `second` dock widget on top of `first` dock widget, creating a tabbed docked area in the main window.

### toolBarArea

    public final Qt.ToolBarArea toolBarArea(QToolBar toolbar)

  Returns the `Qt::ToolBarArea` for `toolbar`. If `toolbar` has not been added to the main window, this function returns `Qt::NoToolBarArea`.

See also:
  `addToolBar()`, `addToolBarBreak()`, and `Qt::ToolBarArea` .

### toolBarBreak

    public final boolean toolBarBreak(QToolBar toolbar)

  Returns whether there is a toolbar break before the `toolbar`.

See also:
  `addToolBarBreak()`, and `insertToolBarBreak()`.

### toolButtonStyle

    public final Qt.ToolButtonStyle toolButtonStyle()

  This property holds style of toolbar buttons in this mainwindow. The default is `Qt::ToolButtonIconOnly` .

### unifiedTitleAndToolBarOnMac

    public final boolean unifiedTitleAndToolBarOnMac()

  This property holds whether the window uses the unified title and toolbar look on Mac OS X. This property is false by default and only has any effect on Mac OS X 10.4 or higher.

  If set to true, then the top toolbar area is replaced with a Carbon HIToolbar and all toolbars in the top toolbar area are moved to that. Any toolbars added afterwards will also be added to the Carbon HIToolbar. This means a couple of things.

  - QToolBars in this toolbar area are not movable and you cannot drag other toolbars to it
  - Toolbar breaks are not respected or preserved
  - Any custom widgets in the toolbar will not be shown if the toolbar becomes too small (only actions will be shown)
  - If you call `showFullScreen()` on the main window, the QToolbar will disappear since it is considered to be part of the title bar. You can work around this by turning off the unified toolbar before you call `showFullScreen()` and restoring it after you call `showNormal()`.
  Setting this back to false will remove these restrictions.

  The `Qt::WA_MacBrushedMetal` attribute takes precedence over this property.

### createPopupMenu

    public QMenu createPopupMenu()

  Returns a popup menu containing checkable entries for the toolbars and dock widgets present in the main window. If there are no toolbars and dock widgets present, this function returns a null pointer.

  By default, this function is called by the main window when the user activates a context menu, typically by right-clicking on a toolbar or a dock widget.

  If you want to create a custom popup menu, reimplement this function and return a newly-created popup menu. Ownership of the popup menu is transferred to the caller.

See also:
  `addDockWidget()`, `addToolBar()`, and `menuBar()`.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD